do
	local Prefs = import('/lua/user/prefs.lua')
	local options = Prefs.GetFromCurrentProfile('options')
	--bigger strategic build icons
	if options.gui_bigger_strat_build_icons != 0 then
		local straticonsfile = import('/mods/GUI/modules/straticons.lua')
		local oldCommonLogic = CommonLogic
		function CommonLogic()
			oldCommonLogic()
			local oldSecondary = controls.secondaryChoices.SetControlToType
			local oldPrimary = controls.choices.SetControlToType
			controls.secondaryChoices.SetControlToType = function(control, type)
				oldSecondary(control, type)
				StratIconReplacement(control)
			end
			controls.choices.SetControlToType = function(control, type)
				oldPrimary(control, type)
				StratIconReplacement(control)
			end
		end
		
		function StratIconReplacement(control)
			if __blueprints[control.Data.id].StrategicIconName then
				local iconName = __blueprints[control.Data.id].StrategicIconName
				local iconConversion = straticonsfile.aSpecificStratIcons[control.Data.id] or straticonsfile.aStratIconTranslation[iconName]
				if iconConversion and DiskGetFileInfo('/mods/GUI/textures/icons_strategic/'..iconConversion..'.dds') then
					control.StratIcon:SetTexture('/mods/GUI/textures/icons_strategic/'..iconConversion..'.dds')
					LayoutHelpers.AtTopIn(control.StratIcon, control.Icon, 1)
					LayoutHelpers.AtRightIn(control.StratIcon, control.Icon, 1)
					LayoutHelpers.ResetBottom(control.StratIcon)
					LayoutHelpers.ResetLeft(control.StratIcon)
					control.StratIcon:SetAlpha(0.8)
				else
					LOG('Strat Icon Mod Error: updated strat icon required for: ', iconName)
				end
			end
		end
	end
	
	--template rotator
	if options.gui_template_rotator != 0 then
		local oldOnClickHandler = OnClickHandler
		function OnClickHandler(button, modifiers)
			oldOnClickHandler(button, modifiers)
			local item = button.Data
			if item.type == "templates" then
				local activeTemplate = item.template.templateData
				local worldview = import('/lua/ui/game/worldview.lua').viewLeft
				local oldHandleEvent = worldview.HandleEvent
				worldview.HandleEvent = function(self, event)
					if event.Type == 'ButtonPress' then
						if event.Modifiers.Middle then
							ClearBuildTemplates()
							local tempTemplate = table.deepcopy(activeTemplate)
							for i = 3, table.getn(activeTemplate) do
								local index = i
								activeTemplate[index][3] = 0 - tempTemplate[index][4]
								activeTemplate[index][4] = tempTemplate[index][3]
							end
							SetActiveBuildTemplate(activeTemplate)
						elseif event.Modifiers.Shift then
						else
							worldview.HandleEvent = oldHandleEvent
						end
					end
				end
			end
		end
	end
end
